/*+
|                                               |
|     Trigger: DTULTATU_TIPOCARGO               |  
|     Tabela : TIPOCARGO                        |
|                                               |
|     Criao:                                  |
|     13/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_TIPOCARGO
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCARGO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPCA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOCARGO,0) <> NVL(:NEW.CDTIPOCARGO,0)) OR
           (NVL(:OLD.NMTIPOCARGO,0) <> NVL(:NEW.NMTIPOCARGO,0)) THEN
         :NEW.DTULTATUTPCA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCARGO'  , '', 'CDTIPOCARGO='||:OLD.CDTIPOCARGO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCARGO MODIFY DTULTATUTPCA DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOCARGO','5.01.008'); END;
/

